// Generated by the protocol buffer compiler.  DO NOT EDIT!
// source: device_properties.proto

#include "device_properties.pb.h"

#include <algorithm>

#include <google/protobuf/io/coded_stream.h>
#include <google/protobuf/extension_set.h>
#include <google/protobuf/wire_format_lite.h>
#include <google/protobuf/descriptor.h>
#include <google/protobuf/generated_message_reflection.h>
#include <google/protobuf/reflection_ops.h>
#include <google/protobuf/wire_format.h>
// @@protoc_insertion_point(includes)
#include <google/protobuf/port_def.inc>
extern PROTOBUF_INTERNAL_EXPORT_value_2eproto ::PROTOBUF_NAMESPACE_ID::internal::SCCInfo<8> scc_info_AttributeValue_value_2eproto;
extern PROTOBUF_INTERNAL_EXPORT_device_5fproperties_2eproto ::PROTOBUF_NAMESPACE_ID::internal::SCCInfo<0> scc_info_DeviceAttributeMeta_MetaEntry_DoNotUse_device_5fproperties_2eproto;
extern PROTOBUF_INTERNAL_EXPORT_device_5fproperties_2eproto ::PROTOBUF_NAMESPACE_ID::internal::SCCInfo<1> scc_info_DeviceProperties_PropertiesEntry_DoNotUse_device_5fproperties_2eproto;
namespace mascot {
class ReadDevicePropertiesMessageDefaultTypeInternal {
 public:
  ::PROTOBUF_NAMESPACE_ID::internal::ExplicitlyConstructed<ReadDevicePropertiesMessage> _instance;
} _ReadDevicePropertiesMessage_default_instance_;
class DeviceProperties_PropertiesEntry_DoNotUseDefaultTypeInternal {
 public:
  ::PROTOBUF_NAMESPACE_ID::internal::ExplicitlyConstructed<DeviceProperties_PropertiesEntry_DoNotUse> _instance;
} _DeviceProperties_PropertiesEntry_DoNotUse_default_instance_;
class DevicePropertiesDefaultTypeInternal {
 public:
  ::PROTOBUF_NAMESPACE_ID::internal::ExplicitlyConstructed<DeviceProperties> _instance;
} _DeviceProperties_default_instance_;
class ReadDeviceAttributeMetaMessageDefaultTypeInternal {
 public:
  ::PROTOBUF_NAMESPACE_ID::internal::ExplicitlyConstructed<ReadDeviceAttributeMetaMessage> _instance;
} _ReadDeviceAttributeMetaMessage_default_instance_;
class DeviceAttributeMeta_MetaEntry_DoNotUseDefaultTypeInternal {
 public:
  ::PROTOBUF_NAMESPACE_ID::internal::ExplicitlyConstructed<DeviceAttributeMeta_MetaEntry_DoNotUse> _instance;
} _DeviceAttributeMeta_MetaEntry_DoNotUse_default_instance_;
class DeviceAttributeMetaDefaultTypeInternal {
 public:
  ::PROTOBUF_NAMESPACE_ID::internal::ExplicitlyConstructed<DeviceAttributeMeta> _instance;
} _DeviceAttributeMeta_default_instance_;
}  // namespace mascot
static void InitDefaultsscc_info_DeviceAttributeMeta_device_5fproperties_2eproto() {
  GOOGLE_PROTOBUF_VERIFY_VERSION;

  {
    void* ptr = &::mascot::_DeviceAttributeMeta_default_instance_;
    new (ptr) ::mascot::DeviceAttributeMeta();
    ::PROTOBUF_NAMESPACE_ID::internal::OnShutdownDestroyMessage(ptr);
  }
  ::mascot::DeviceAttributeMeta::InitAsDefaultInstance();
}

::PROTOBUF_NAMESPACE_ID::internal::SCCInfo<1> scc_info_DeviceAttributeMeta_device_5fproperties_2eproto =
    {{ATOMIC_VAR_INIT(::PROTOBUF_NAMESPACE_ID::internal::SCCInfoBase::kUninitialized), 1, 0, InitDefaultsscc_info_DeviceAttributeMeta_device_5fproperties_2eproto}, {
      &scc_info_DeviceAttributeMeta_MetaEntry_DoNotUse_device_5fproperties_2eproto.base,}};

static void InitDefaultsscc_info_DeviceAttributeMeta_MetaEntry_DoNotUse_device_5fproperties_2eproto() {
  GOOGLE_PROTOBUF_VERIFY_VERSION;

  {
    void* ptr = &::mascot::_DeviceAttributeMeta_MetaEntry_DoNotUse_default_instance_;
    new (ptr) ::mascot::DeviceAttributeMeta_MetaEntry_DoNotUse();
  }
  ::mascot::DeviceAttributeMeta_MetaEntry_DoNotUse::InitAsDefaultInstance();
}

::PROTOBUF_NAMESPACE_ID::internal::SCCInfo<0> scc_info_DeviceAttributeMeta_MetaEntry_DoNotUse_device_5fproperties_2eproto =
    {{ATOMIC_VAR_INIT(::PROTOBUF_NAMESPACE_ID::internal::SCCInfoBase::kUninitialized), 0, 0, InitDefaultsscc_info_DeviceAttributeMeta_MetaEntry_DoNotUse_device_5fproperties_2eproto}, {}};

static void InitDefaultsscc_info_DeviceProperties_device_5fproperties_2eproto() {
  GOOGLE_PROTOBUF_VERIFY_VERSION;

  {
    void* ptr = &::mascot::_DeviceProperties_default_instance_;
    new (ptr) ::mascot::DeviceProperties();
    ::PROTOBUF_NAMESPACE_ID::internal::OnShutdownDestroyMessage(ptr);
  }
  ::mascot::DeviceProperties::InitAsDefaultInstance();
}

::PROTOBUF_NAMESPACE_ID::internal::SCCInfo<1> scc_info_DeviceProperties_device_5fproperties_2eproto =
    {{ATOMIC_VAR_INIT(::PROTOBUF_NAMESPACE_ID::internal::SCCInfoBase::kUninitialized), 1, 0, InitDefaultsscc_info_DeviceProperties_device_5fproperties_2eproto}, {
      &scc_info_DeviceProperties_PropertiesEntry_DoNotUse_device_5fproperties_2eproto.base,}};

static void InitDefaultsscc_info_DeviceProperties_PropertiesEntry_DoNotUse_device_5fproperties_2eproto() {
  GOOGLE_PROTOBUF_VERIFY_VERSION;

  {
    void* ptr = &::mascot::_DeviceProperties_PropertiesEntry_DoNotUse_default_instance_;
    new (ptr) ::mascot::DeviceProperties_PropertiesEntry_DoNotUse();
  }
  ::mascot::DeviceProperties_PropertiesEntry_DoNotUse::InitAsDefaultInstance();
}

::PROTOBUF_NAMESPACE_ID::internal::SCCInfo<1> scc_info_DeviceProperties_PropertiesEntry_DoNotUse_device_5fproperties_2eproto =
    {{ATOMIC_VAR_INIT(::PROTOBUF_NAMESPACE_ID::internal::SCCInfoBase::kUninitialized), 1, 0, InitDefaultsscc_info_DeviceProperties_PropertiesEntry_DoNotUse_device_5fproperties_2eproto}, {
      &scc_info_AttributeValue_value_2eproto.base,}};

static void InitDefaultsscc_info_ReadDeviceAttributeMetaMessage_device_5fproperties_2eproto() {
  GOOGLE_PROTOBUF_VERIFY_VERSION;

  {
    void* ptr = &::mascot::_ReadDeviceAttributeMetaMessage_default_instance_;
    new (ptr) ::mascot::ReadDeviceAttributeMetaMessage();
    ::PROTOBUF_NAMESPACE_ID::internal::OnShutdownDestroyMessage(ptr);
  }
  ::mascot::ReadDeviceAttributeMetaMessage::InitAsDefaultInstance();
}

::PROTOBUF_NAMESPACE_ID::internal::SCCInfo<0> scc_info_ReadDeviceAttributeMetaMessage_device_5fproperties_2eproto =
    {{ATOMIC_VAR_INIT(::PROTOBUF_NAMESPACE_ID::internal::SCCInfoBase::kUninitialized), 0, 0, InitDefaultsscc_info_ReadDeviceAttributeMetaMessage_device_5fproperties_2eproto}, {}};

static void InitDefaultsscc_info_ReadDevicePropertiesMessage_device_5fproperties_2eproto() {
  GOOGLE_PROTOBUF_VERIFY_VERSION;

  {
    void* ptr = &::mascot::_ReadDevicePropertiesMessage_default_instance_;
    new (ptr) ::mascot::ReadDevicePropertiesMessage();
    ::PROTOBUF_NAMESPACE_ID::internal::OnShutdownDestroyMessage(ptr);
  }
  ::mascot::ReadDevicePropertiesMessage::InitAsDefaultInstance();
}

::PROTOBUF_NAMESPACE_ID::internal::SCCInfo<0> scc_info_ReadDevicePropertiesMessage_device_5fproperties_2eproto =
    {{ATOMIC_VAR_INIT(::PROTOBUF_NAMESPACE_ID::internal::SCCInfoBase::kUninitialized), 0, 0, InitDefaultsscc_info_ReadDevicePropertiesMessage_device_5fproperties_2eproto}, {}};

static ::PROTOBUF_NAMESPACE_ID::Metadata file_level_metadata_device_5fproperties_2eproto[6];
static constexpr ::PROTOBUF_NAMESPACE_ID::EnumDescriptor const** file_level_enum_descriptors_device_5fproperties_2eproto = nullptr;
static constexpr ::PROTOBUF_NAMESPACE_ID::ServiceDescriptor const** file_level_service_descriptors_device_5fproperties_2eproto = nullptr;

const ::PROTOBUF_NAMESPACE_ID::uint32 TableStruct_device_5fproperties_2eproto::offsets[] PROTOBUF_SECTION_VARIABLE(protodesc_cold) = {
  ~0u,  // no _has_bits_
  PROTOBUF_FIELD_OFFSET(::mascot::ReadDevicePropertiesMessage, _internal_metadata_),
  ~0u,  // no _extensions_
  ~0u,  // no _oneof_case_
  ~0u,  // no _weak_field_map_
  PROTOBUF_FIELD_OFFSET(::mascot::ReadDevicePropertiesMessage, devicename_),
  PROTOBUF_FIELD_OFFSET(::mascot::DeviceProperties_PropertiesEntry_DoNotUse, _has_bits_),
  PROTOBUF_FIELD_OFFSET(::mascot::DeviceProperties_PropertiesEntry_DoNotUse, _internal_metadata_),
  ~0u,  // no _extensions_
  ~0u,  // no _oneof_case_
  ~0u,  // no _weak_field_map_
  PROTOBUF_FIELD_OFFSET(::mascot::DeviceProperties_PropertiesEntry_DoNotUse, key_),
  PROTOBUF_FIELD_OFFSET(::mascot::DeviceProperties_PropertiesEntry_DoNotUse, value_),
  0,
  1,
  ~0u,  // no _has_bits_
  PROTOBUF_FIELD_OFFSET(::mascot::DeviceProperties, _internal_metadata_),
  ~0u,  // no _extensions_
  ~0u,  // no _oneof_case_
  ~0u,  // no _weak_field_map_
  PROTOBUF_FIELD_OFFSET(::mascot::DeviceProperties, devicename_),
  PROTOBUF_FIELD_OFFSET(::mascot::DeviceProperties, properties_),
  ~0u,  // no _has_bits_
  PROTOBUF_FIELD_OFFSET(::mascot::ReadDeviceAttributeMetaMessage, _internal_metadata_),
  ~0u,  // no _extensions_
  ~0u,  // no _oneof_case_
  ~0u,  // no _weak_field_map_
  PROTOBUF_FIELD_OFFSET(::mascot::ReadDeviceAttributeMetaMessage, devicename_),
  PROTOBUF_FIELD_OFFSET(::mascot::ReadDeviceAttributeMetaMessage, attributename_),
  PROTOBUF_FIELD_OFFSET(::mascot::DeviceAttributeMeta_MetaEntry_DoNotUse, _has_bits_),
  PROTOBUF_FIELD_OFFSET(::mascot::DeviceAttributeMeta_MetaEntry_DoNotUse, _internal_metadata_),
  ~0u,  // no _extensions_
  ~0u,  // no _oneof_case_
  ~0u,  // no _weak_field_map_
  PROTOBUF_FIELD_OFFSET(::mascot::DeviceAttributeMeta_MetaEntry_DoNotUse, key_),
  PROTOBUF_FIELD_OFFSET(::mascot::DeviceAttributeMeta_MetaEntry_DoNotUse, value_),
  0,
  1,
  ~0u,  // no _has_bits_
  PROTOBUF_FIELD_OFFSET(::mascot::DeviceAttributeMeta, _internal_metadata_),
  ~0u,  // no _extensions_
  ~0u,  // no _oneof_case_
  ~0u,  // no _weak_field_map_
  PROTOBUF_FIELD_OFFSET(::mascot::DeviceAttributeMeta, devicename_),
  PROTOBUF_FIELD_OFFSET(::mascot::DeviceAttributeMeta, attributename_),
  PROTOBUF_FIELD_OFFSET(::mascot::DeviceAttributeMeta, meta_),
};
static const ::PROTOBUF_NAMESPACE_ID::internal::MigrationSchema schemas[] PROTOBUF_SECTION_VARIABLE(protodesc_cold) = {
  { 0, -1, sizeof(::mascot::ReadDevicePropertiesMessage)},
  { 6, 13, sizeof(::mascot::DeviceProperties_PropertiesEntry_DoNotUse)},
  { 15, -1, sizeof(::mascot::DeviceProperties)},
  { 22, -1, sizeof(::mascot::ReadDeviceAttributeMetaMessage)},
  { 29, 36, sizeof(::mascot::DeviceAttributeMeta_MetaEntry_DoNotUse)},
  { 38, -1, sizeof(::mascot::DeviceAttributeMeta)},
};

static ::PROTOBUF_NAMESPACE_ID::Message const * const file_default_instances[] = {
  reinterpret_cast<const ::PROTOBUF_NAMESPACE_ID::Message*>(&::mascot::_ReadDevicePropertiesMessage_default_instance_),
  reinterpret_cast<const ::PROTOBUF_NAMESPACE_ID::Message*>(&::mascot::_DeviceProperties_PropertiesEntry_DoNotUse_default_instance_),
  reinterpret_cast<const ::PROTOBUF_NAMESPACE_ID::Message*>(&::mascot::_DeviceProperties_default_instance_),
  reinterpret_cast<const ::PROTOBUF_NAMESPACE_ID::Message*>(&::mascot::_ReadDeviceAttributeMetaMessage_default_instance_),
  reinterpret_cast<const ::PROTOBUF_NAMESPACE_ID::Message*>(&::mascot::_DeviceAttributeMeta_MetaEntry_DoNotUse_default_instance_),
  reinterpret_cast<const ::PROTOBUF_NAMESPACE_ID::Message*>(&::mascot::_DeviceAttributeMeta_default_instance_),
};

const char descriptor_table_protodef_device_5fproperties_2eproto[] PROTOBUF_SECTION_VARIABLE(protodesc_cold) =
  "\n\027device_properties.proto\022\006mascot\032\013value"
  ".proto\"1\n\033ReadDevicePropertiesMessage\022\022\n"
  "\ndeviceName\030\001 \001(\t\"\257\001\n\020DeviceProperties\022\022"
  "\n\ndeviceName\030\001 \001(\t\022<\n\nproperties\030\002 \003(\0132("
  ".mascot.DeviceProperties.PropertiesEntry"
  "\032I\n\017PropertiesEntry\022\013\n\003key\030\001 \001(\t\022%\n\005valu"
  "e\030\002 \001(\0132\026.mascot.AttributeValue:\0028\001\"K\n\036R"
  "eadDeviceAttributeMetaMessage\022\022\n\ndeviceN"
  "ame\030\001 \001(\t\022\025\n\rattributeName\030\002 \001(\t\"\242\001\n\023Dev"
  "iceAttributeMeta\022\022\n\ndeviceName\030\001 \001(\t\022\025\n\r"
  "attributeName\030\002 \001(\t\0223\n\004meta\030\003 \003(\0132%.masc"
  "ot.DeviceAttributeMeta.MetaEntry\032+\n\tMeta"
  "Entry\022\013\n\003key\030\001 \001(\t\022\r\n\005value\030\002 \001(\t:\0028\001b\006p"
  "roto3"
  ;
static const ::PROTOBUF_NAMESPACE_ID::internal::DescriptorTable*const descriptor_table_device_5fproperties_2eproto_deps[1] = {
  &::descriptor_table_value_2eproto,
};
static ::PROTOBUF_NAMESPACE_ID::internal::SCCInfoBase*const descriptor_table_device_5fproperties_2eproto_sccs[6] = {
  &scc_info_DeviceAttributeMeta_device_5fproperties_2eproto.base,
  &scc_info_DeviceAttributeMeta_MetaEntry_DoNotUse_device_5fproperties_2eproto.base,
  &scc_info_DeviceProperties_device_5fproperties_2eproto.base,
  &scc_info_DeviceProperties_PropertiesEntry_DoNotUse_device_5fproperties_2eproto.base,
  &scc_info_ReadDeviceAttributeMetaMessage_device_5fproperties_2eproto.base,
  &scc_info_ReadDevicePropertiesMessage_device_5fproperties_2eproto.base,
};
static ::PROTOBUF_NAMESPACE_ID::internal::once_flag descriptor_table_device_5fproperties_2eproto_once;
const ::PROTOBUF_NAMESPACE_ID::internal::DescriptorTable descriptor_table_device_5fproperties_2eproto = {
  false, false, descriptor_table_protodef_device_5fproperties_2eproto, "device_properties.proto", 525,
  &descriptor_table_device_5fproperties_2eproto_once, descriptor_table_device_5fproperties_2eproto_sccs, descriptor_table_device_5fproperties_2eproto_deps, 6, 1,
  schemas, file_default_instances, TableStruct_device_5fproperties_2eproto::offsets,
  file_level_metadata_device_5fproperties_2eproto, 6, file_level_enum_descriptors_device_5fproperties_2eproto, file_level_service_descriptors_device_5fproperties_2eproto,
};

// Force running AddDescriptors() at dynamic initialization time.
static bool dynamic_init_dummy_device_5fproperties_2eproto = (static_cast<void>(::PROTOBUF_NAMESPACE_ID::internal::AddDescriptors(&descriptor_table_device_5fproperties_2eproto)), true);
namespace mascot {

// ===================================================================

void ReadDevicePropertiesMessage::InitAsDefaultInstance() {
}
class ReadDevicePropertiesMessage::_Internal {
 public:
};

ReadDevicePropertiesMessage::ReadDevicePropertiesMessage(::PROTOBUF_NAMESPACE_ID::Arena* arena)
  : ::PROTOBUF_NAMESPACE_ID::Message(arena) {
  SharedCtor();
  RegisterArenaDtor(arena);
  // @@protoc_insertion_point(arena_constructor:mascot.ReadDevicePropertiesMessage)
}
ReadDevicePropertiesMessage::ReadDevicePropertiesMessage(const ReadDevicePropertiesMessage& from)
  : ::PROTOBUF_NAMESPACE_ID::Message() {
  _internal_metadata_.MergeFrom<::PROTOBUF_NAMESPACE_ID::UnknownFieldSet>(from._internal_metadata_);
  devicename_.UnsafeSetDefault(&::PROTOBUF_NAMESPACE_ID::internal::GetEmptyStringAlreadyInited());
  if (!from._internal_devicename().empty()) {
    devicename_.Set(&::PROTOBUF_NAMESPACE_ID::internal::GetEmptyStringAlreadyInited(), from._internal_devicename(),
      GetArena());
  }
  // @@protoc_insertion_point(copy_constructor:mascot.ReadDevicePropertiesMessage)
}

void ReadDevicePropertiesMessage::SharedCtor() {
  ::PROTOBUF_NAMESPACE_ID::internal::InitSCC(&scc_info_ReadDevicePropertiesMessage_device_5fproperties_2eproto.base);
  devicename_.UnsafeSetDefault(&::PROTOBUF_NAMESPACE_ID::internal::GetEmptyStringAlreadyInited());
}

ReadDevicePropertiesMessage::~ReadDevicePropertiesMessage() {
  // @@protoc_insertion_point(destructor:mascot.ReadDevicePropertiesMessage)
  SharedDtor();
  _internal_metadata_.Delete<::PROTOBUF_NAMESPACE_ID::UnknownFieldSet>();
}

void ReadDevicePropertiesMessage::SharedDtor() {
  GOOGLE_DCHECK(GetArena() == nullptr);
  devicename_.DestroyNoArena(&::PROTOBUF_NAMESPACE_ID::internal::GetEmptyStringAlreadyInited());
}

void ReadDevicePropertiesMessage::ArenaDtor(void* object) {
  ReadDevicePropertiesMessage* _this = reinterpret_cast< ReadDevicePropertiesMessage* >(object);
  (void)_this;
}
void ReadDevicePropertiesMessage::RegisterArenaDtor(::PROTOBUF_NAMESPACE_ID::Arena*) {
}
void ReadDevicePropertiesMessage::SetCachedSize(int size) const {
  _cached_size_.Set(size);
}
const ReadDevicePropertiesMessage& ReadDevicePropertiesMessage::default_instance() {
  ::PROTOBUF_NAMESPACE_ID::internal::InitSCC(&::scc_info_ReadDevicePropertiesMessage_device_5fproperties_2eproto.base);
  return *internal_default_instance();
}


void ReadDevicePropertiesMessage::Clear() {
// @@protoc_insertion_point(message_clear_start:mascot.ReadDevicePropertiesMessage)
  ::PROTOBUF_NAMESPACE_ID::uint32 cached_has_bits = 0;
  // Prevent compiler warnings about cached_has_bits being unused
  (void) cached_has_bits;

  devicename_.ClearToEmpty(&::PROTOBUF_NAMESPACE_ID::internal::GetEmptyStringAlreadyInited(), GetArena());
  _internal_metadata_.Clear<::PROTOBUF_NAMESPACE_ID::UnknownFieldSet>();
}

const char* ReadDevicePropertiesMessage::_InternalParse(const char* ptr, ::PROTOBUF_NAMESPACE_ID::internal::ParseContext* ctx) {
#define CHK_(x) if (PROTOBUF_PREDICT_FALSE(!(x))) goto failure
  ::PROTOBUF_NAMESPACE_ID::Arena* arena = GetArena(); (void)arena;
  while (!ctx->Done(&ptr)) {
    ::PROTOBUF_NAMESPACE_ID::uint32 tag;
    ptr = ::PROTOBUF_NAMESPACE_ID::internal::ReadTag(ptr, &tag);
    CHK_(ptr);
    switch (tag >> 3) {
      // string deviceName = 1;
      case 1:
        if (PROTOBUF_PREDICT_TRUE(static_cast<::PROTOBUF_NAMESPACE_ID::uint8>(tag) == 10)) {
          auto str = _internal_mutable_devicename();
          ptr = ::PROTOBUF_NAMESPACE_ID::internal::InlineGreedyStringParser(str, ptr, ctx);
          CHK_(::PROTOBUF_NAMESPACE_ID::internal::VerifyUTF8(str, "mascot.ReadDevicePropertiesMessage.deviceName"));
          CHK_(ptr);
        } else goto handle_unusual;
        continue;
      default: {
      handle_unusual:
        if ((tag & 7) == 4 || tag == 0) {
          ctx->SetLastTag(tag);
          goto success;
        }
        ptr = UnknownFieldParse(tag,
            _internal_metadata_.mutable_unknown_fields<::PROTOBUF_NAMESPACE_ID::UnknownFieldSet>(),
            ptr, ctx);
        CHK_(ptr != nullptr);
        continue;
      }
    }  // switch
  }  // while
success:
  return ptr;
failure:
  ptr = nullptr;
  goto success;
#undef CHK_
}

::PROTOBUF_NAMESPACE_ID::uint8* ReadDevicePropertiesMessage::_InternalSerialize(
    ::PROTOBUF_NAMESPACE_ID::uint8* target, ::PROTOBUF_NAMESPACE_ID::io::EpsCopyOutputStream* stream) const {
  // @@protoc_insertion_point(serialize_to_array_start:mascot.ReadDevicePropertiesMessage)
  ::PROTOBUF_NAMESPACE_ID::uint32 cached_has_bits = 0;
  (void) cached_has_bits;

  // string deviceName = 1;
  if (this->devicename().size() > 0) {
    ::PROTOBUF_NAMESPACE_ID::internal::WireFormatLite::VerifyUtf8String(
      this->_internal_devicename().data(), static_cast<int>(this->_internal_devicename().length()),
      ::PROTOBUF_NAMESPACE_ID::internal::WireFormatLite::SERIALIZE,
      "mascot.ReadDevicePropertiesMessage.deviceName");
    target = stream->WriteStringMaybeAliased(
        1, this->_internal_devicename(), target);
  }

  if (PROTOBUF_PREDICT_FALSE(_internal_metadata_.have_unknown_fields())) {
    target = ::PROTOBUF_NAMESPACE_ID::internal::WireFormat::InternalSerializeUnknownFieldsToArray(
        _internal_metadata_.unknown_fields<::PROTOBUF_NAMESPACE_ID::UnknownFieldSet>(::PROTOBUF_NAMESPACE_ID::UnknownFieldSet::default_instance), target, stream);
  }
  // @@protoc_insertion_point(serialize_to_array_end:mascot.ReadDevicePropertiesMessage)
  return target;
}

size_t ReadDevicePropertiesMessage::ByteSizeLong() const {
// @@protoc_insertion_point(message_byte_size_start:mascot.ReadDevicePropertiesMessage)
  size_t total_size = 0;

  ::PROTOBUF_NAMESPACE_ID::uint32 cached_has_bits = 0;
  // Prevent compiler warnings about cached_has_bits being unused
  (void) cached_has_bits;

  // string deviceName = 1;
  if (this->devicename().size() > 0) {
    total_size += 1 +
      ::PROTOBUF_NAMESPACE_ID::internal::WireFormatLite::StringSize(
        this->_internal_devicename());
  }

  if (PROTOBUF_PREDICT_FALSE(_internal_metadata_.have_unknown_fields())) {
    return ::PROTOBUF_NAMESPACE_ID::internal::ComputeUnknownFieldsSize(
        _internal_metadata_, total_size, &_cached_size_);
  }
  int cached_size = ::PROTOBUF_NAMESPACE_ID::internal::ToCachedSize(total_size);
  SetCachedSize(cached_size);
  return total_size;
}

void ReadDevicePropertiesMessage::MergeFrom(const ::PROTOBUF_NAMESPACE_ID::Message& from) {
// @@protoc_insertion_point(generalized_merge_from_start:mascot.ReadDevicePropertiesMessage)
  GOOGLE_DCHECK_NE(&from, this);
  const ReadDevicePropertiesMessage* source =
      ::PROTOBUF_NAMESPACE_ID::DynamicCastToGenerated<ReadDevicePropertiesMessage>(
          &from);
  if (source == nullptr) {
  // @@protoc_insertion_point(generalized_merge_from_cast_fail:mascot.ReadDevicePropertiesMessage)
    ::PROTOBUF_NAMESPACE_ID::internal::ReflectionOps::Merge(from, this);
  } else {
  // @@protoc_insertion_point(generalized_merge_from_cast_success:mascot.ReadDevicePropertiesMessage)
    MergeFrom(*source);
  }
}

void ReadDevicePropertiesMessage::MergeFrom(const ReadDevicePropertiesMessage& from) {
// @@protoc_insertion_point(class_specific_merge_from_start:mascot.ReadDevicePropertiesMessage)
  GOOGLE_DCHECK_NE(&from, this);
  _internal_metadata_.MergeFrom<::PROTOBUF_NAMESPACE_ID::UnknownFieldSet>(from._internal_metadata_);
  ::PROTOBUF_NAMESPACE_ID::uint32 cached_has_bits = 0;
  (void) cached_has_bits;

  if (from.devicename().size() > 0) {
    _internal_set_devicename(from._internal_devicename());
  }
}

void ReadDevicePropertiesMessage::CopyFrom(const ::PROTOBUF_NAMESPACE_ID::Message& from) {
// @@protoc_insertion_point(generalized_copy_from_start:mascot.ReadDevicePropertiesMessage)
  if (&from == this) return;
  Clear();
  MergeFrom(from);
}

void ReadDevicePropertiesMessage::CopyFrom(const ReadDevicePropertiesMessage& from) {
// @@protoc_insertion_point(class_specific_copy_from_start:mascot.ReadDevicePropertiesMessage)
  if (&from == this) return;
  Clear();
  MergeFrom(from);
}

bool ReadDevicePropertiesMessage::IsInitialized() const {
  return true;
}

void ReadDevicePropertiesMessage::InternalSwap(ReadDevicePropertiesMessage* other) {
  using std::swap;
  _internal_metadata_.Swap<::PROTOBUF_NAMESPACE_ID::UnknownFieldSet>(&other->_internal_metadata_);
  devicename_.Swap(&other->devicename_, &::PROTOBUF_NAMESPACE_ID::internal::GetEmptyStringAlreadyInited(), GetArena());
}

::PROTOBUF_NAMESPACE_ID::Metadata ReadDevicePropertiesMessage::GetMetadata() const {
  return GetMetadataStatic();
}


// ===================================================================

DeviceProperties_PropertiesEntry_DoNotUse::DeviceProperties_PropertiesEntry_DoNotUse() {}
DeviceProperties_PropertiesEntry_DoNotUse::DeviceProperties_PropertiesEntry_DoNotUse(::PROTOBUF_NAMESPACE_ID::Arena* arena)
    : SuperType(arena) {}
void DeviceProperties_PropertiesEntry_DoNotUse::MergeFrom(const DeviceProperties_PropertiesEntry_DoNotUse& other) {
  MergeFromInternal(other);
}
::PROTOBUF_NAMESPACE_ID::Metadata DeviceProperties_PropertiesEntry_DoNotUse::GetMetadata() const {
  return GetMetadataStatic();
}
void DeviceProperties_PropertiesEntry_DoNotUse::MergeFrom(
    const ::PROTOBUF_NAMESPACE_ID::Message& other) {
  ::PROTOBUF_NAMESPACE_ID::Message::MergeFrom(other);
}


// ===================================================================

void DeviceProperties::InitAsDefaultInstance() {
}
class DeviceProperties::_Internal {
 public:
};

void DeviceProperties::clear_properties() {
  properties_.Clear();
}
DeviceProperties::DeviceProperties(::PROTOBUF_NAMESPACE_ID::Arena* arena)
  : ::PROTOBUF_NAMESPACE_ID::Message(arena),
  properties_(arena) {
  SharedCtor();
  RegisterArenaDtor(arena);
  // @@protoc_insertion_point(arena_constructor:mascot.DeviceProperties)
}
DeviceProperties::DeviceProperties(const DeviceProperties& from)
  : ::PROTOBUF_NAMESPACE_ID::Message() {
  _internal_metadata_.MergeFrom<::PROTOBUF_NAMESPACE_ID::UnknownFieldSet>(from._internal_metadata_);
  properties_.MergeFrom(from.properties_);
  devicename_.UnsafeSetDefault(&::PROTOBUF_NAMESPACE_ID::internal::GetEmptyStringAlreadyInited());
  if (!from._internal_devicename().empty()) {
    devicename_.Set(&::PROTOBUF_NAMESPACE_ID::internal::GetEmptyStringAlreadyInited(), from._internal_devicename(),
      GetArena());
  }
  // @@protoc_insertion_point(copy_constructor:mascot.DeviceProperties)
}

void DeviceProperties::SharedCtor() {
  ::PROTOBUF_NAMESPACE_ID::internal::InitSCC(&scc_info_DeviceProperties_device_5fproperties_2eproto.base);
  devicename_.UnsafeSetDefault(&::PROTOBUF_NAMESPACE_ID::internal::GetEmptyStringAlreadyInited());
}

DeviceProperties::~DeviceProperties() {
  // @@protoc_insertion_point(destructor:mascot.DeviceProperties)
  SharedDtor();
  _internal_metadata_.Delete<::PROTOBUF_NAMESPACE_ID::UnknownFieldSet>();
}

void DeviceProperties::SharedDtor() {
  GOOGLE_DCHECK(GetArena() == nullptr);
  devicename_.DestroyNoArena(&::PROTOBUF_NAMESPACE_ID::internal::GetEmptyStringAlreadyInited());
}

void DeviceProperties::ArenaDtor(void* object) {
  DeviceProperties* _this = reinterpret_cast< DeviceProperties* >(object);
  (void)_this;
}
void DeviceProperties::RegisterArenaDtor(::PROTOBUF_NAMESPACE_ID::Arena*) {
}
void DeviceProperties::SetCachedSize(int size) const {
  _cached_size_.Set(size);
}
const DeviceProperties& DeviceProperties::default_instance() {
  ::PROTOBUF_NAMESPACE_ID::internal::InitSCC(&::scc_info_DeviceProperties_device_5fproperties_2eproto.base);
  return *internal_default_instance();
}


void DeviceProperties::Clear() {
// @@protoc_insertion_point(message_clear_start:mascot.DeviceProperties)
  ::PROTOBUF_NAMESPACE_ID::uint32 cached_has_bits = 0;
  // Prevent compiler warnings about cached_has_bits being unused
  (void) cached_has_bits;

  properties_.Clear();
  devicename_.ClearToEmpty(&::PROTOBUF_NAMESPACE_ID::internal::GetEmptyStringAlreadyInited(), GetArena());
  _internal_metadata_.Clear<::PROTOBUF_NAMESPACE_ID::UnknownFieldSet>();
}

const char* DeviceProperties::_InternalParse(const char* ptr, ::PROTOBUF_NAMESPACE_ID::internal::ParseContext* ctx) {
#define CHK_(x) if (PROTOBUF_PREDICT_FALSE(!(x))) goto failure
  ::PROTOBUF_NAMESPACE_ID::Arena* arena = GetArena(); (void)arena;
  while (!ctx->Done(&ptr)) {
    ::PROTOBUF_NAMESPACE_ID::uint32 tag;
    ptr = ::PROTOBUF_NAMESPACE_ID::internal::ReadTag(ptr, &tag);
    CHK_(ptr);
    switch (tag >> 3) {
      // string deviceName = 1;
      case 1:
        if (PROTOBUF_PREDICT_TRUE(static_cast<::PROTOBUF_NAMESPACE_ID::uint8>(tag) == 10)) {
          auto str = _internal_mutable_devicename();
          ptr = ::PROTOBUF_NAMESPACE_ID::internal::InlineGreedyStringParser(str, ptr, ctx);
          CHK_(::PROTOBUF_NAMESPACE_ID::internal::VerifyUTF8(str, "mascot.DeviceProperties.deviceName"));
          CHK_(ptr);
        } else goto handle_unusual;
        continue;
      // map<string, .mascot.AttributeValue> properties = 2;
      case 2:
        if (PROTOBUF_PREDICT_TRUE(static_cast<::PROTOBUF_NAMESPACE_ID::uint8>(tag) == 18)) {
          ptr -= 1;
          do {
            ptr += 1;
            ptr = ctx->ParseMessage(&properties_, ptr);
            CHK_(ptr);
            if (!ctx->DataAvailable(ptr)) break;
          } while (::PROTOBUF_NAMESPACE_ID::internal::ExpectTag<18>(ptr));
        } else goto handle_unusual;
        continue;
      default: {
      handle_unusual:
        if ((tag & 7) == 4 || tag == 0) {
          ctx->SetLastTag(tag);
          goto success;
        }
        ptr = UnknownFieldParse(tag,
            _internal_metadata_.mutable_unknown_fields<::PROTOBUF_NAMESPACE_ID::UnknownFieldSet>(),
            ptr, ctx);
        CHK_(ptr != nullptr);
        continue;
      }
    }  // switch
  }  // while
success:
  return ptr;
failure:
  ptr = nullptr;
  goto success;
#undef CHK_
}

::PROTOBUF_NAMESPACE_ID::uint8* DeviceProperties::_InternalSerialize(
    ::PROTOBUF_NAMESPACE_ID::uint8* target, ::PROTOBUF_NAMESPACE_ID::io::EpsCopyOutputStream* stream) const {
  // @@protoc_insertion_point(serialize_to_array_start:mascot.DeviceProperties)
  ::PROTOBUF_NAMESPACE_ID::uint32 cached_has_bits = 0;
  (void) cached_has_bits;

  // string deviceName = 1;
  if (this->devicename().size() > 0) {
    ::PROTOBUF_NAMESPACE_ID::internal::WireFormatLite::VerifyUtf8String(
      this->_internal_devicename().data(), static_cast<int>(this->_internal_devicename().length()),
      ::PROTOBUF_NAMESPACE_ID::internal::WireFormatLite::SERIALIZE,
      "mascot.DeviceProperties.deviceName");
    target = stream->WriteStringMaybeAliased(
        1, this->_internal_devicename(), target);
  }

  // map<string, .mascot.AttributeValue> properties = 2;
  if (!this->_internal_properties().empty()) {
    typedef ::PROTOBUF_NAMESPACE_ID::Map< std::string, ::mascot::AttributeValue >::const_pointer
        ConstPtr;
    typedef ConstPtr SortItem;
    typedef ::PROTOBUF_NAMESPACE_ID::internal::CompareByDerefFirst<SortItem> Less;
    struct Utf8Check {
      static void Check(ConstPtr p) {
        ::PROTOBUF_NAMESPACE_ID::internal::WireFormatLite::VerifyUtf8String(
          p->first.data(), static_cast<int>(p->first.length()),
          ::PROTOBUF_NAMESPACE_ID::internal::WireFormatLite::SERIALIZE,
          "mascot.DeviceProperties.PropertiesEntry.key");
      }
    };

    if (stream->IsSerializationDeterministic() &&
        this->_internal_properties().size() > 1) {
      ::std::unique_ptr<SortItem[]> items(
          new SortItem[this->_internal_properties().size()]);
      typedef ::PROTOBUF_NAMESPACE_ID::Map< std::string, ::mascot::AttributeValue >::size_type size_type;
      size_type n = 0;
      for (::PROTOBUF_NAMESPACE_ID::Map< std::string, ::mascot::AttributeValue >::const_iterator
          it = this->_internal_properties().begin();
          it != this->_internal_properties().end(); ++it, ++n) {
        items[static_cast<ptrdiff_t>(n)] = SortItem(&*it);
      }
      ::std::sort(&items[0], &items[static_cast<ptrdiff_t>(n)], Less());
      for (size_type i = 0; i < n; i++) {
        target = DeviceProperties_PropertiesEntry_DoNotUse::Funcs::InternalSerialize(2, items[static_cast<ptrdiff_t>(i)]->first, items[static_cast<ptrdiff_t>(i)]->second, target, stream);
        Utf8Check::Check(&(*items[static_cast<ptrdiff_t>(i)]));
      }
    } else {
      for (::PROTOBUF_NAMESPACE_ID::Map< std::string, ::mascot::AttributeValue >::const_iterator
          it = this->_internal_properties().begin();
          it != this->_internal_properties().end(); ++it) {
        target = DeviceProperties_PropertiesEntry_DoNotUse::Funcs::InternalSerialize(2, it->first, it->second, target, stream);
        Utf8Check::Check(&(*it));
      }
    }
  }

  if (PROTOBUF_PREDICT_FALSE(_internal_metadata_.have_unknown_fields())) {
    target = ::PROTOBUF_NAMESPACE_ID::internal::WireFormat::InternalSerializeUnknownFieldsToArray(
        _internal_metadata_.unknown_fields<::PROTOBUF_NAMESPACE_ID::UnknownFieldSet>(::PROTOBUF_NAMESPACE_ID::UnknownFieldSet::default_instance), target, stream);
  }
  // @@protoc_insertion_point(serialize_to_array_end:mascot.DeviceProperties)
  return target;
}

size_t DeviceProperties::ByteSizeLong() const {
// @@protoc_insertion_point(message_byte_size_start:mascot.DeviceProperties)
  size_t total_size = 0;

  ::PROTOBUF_NAMESPACE_ID::uint32 cached_has_bits = 0;
  // Prevent compiler warnings about cached_has_bits being unused
  (void) cached_has_bits;

  // map<string, .mascot.AttributeValue> properties = 2;
  total_size += 1 *
      ::PROTOBUF_NAMESPACE_ID::internal::FromIntSize(this->_internal_properties_size());
  for (::PROTOBUF_NAMESPACE_ID::Map< std::string, ::mascot::AttributeValue >::const_iterator
      it = this->_internal_properties().begin();
      it != this->_internal_properties().end(); ++it) {
    total_size += DeviceProperties_PropertiesEntry_DoNotUse::Funcs::ByteSizeLong(it->first, it->second);
  }

  // string deviceName = 1;
  if (this->devicename().size() > 0) {
    total_size += 1 +
      ::PROTOBUF_NAMESPACE_ID::internal::WireFormatLite::StringSize(
        this->_internal_devicename());
  }

  if (PROTOBUF_PREDICT_FALSE(_internal_metadata_.have_unknown_fields())) {
    return ::PROTOBUF_NAMESPACE_ID::internal::ComputeUnknownFieldsSize(
        _internal_metadata_, total_size, &_cached_size_);
  }
  int cached_size = ::PROTOBUF_NAMESPACE_ID::internal::ToCachedSize(total_size);
  SetCachedSize(cached_size);
  return total_size;
}

void DeviceProperties::MergeFrom(const ::PROTOBUF_NAMESPACE_ID::Message& from) {
// @@protoc_insertion_point(generalized_merge_from_start:mascot.DeviceProperties)
  GOOGLE_DCHECK_NE(&from, this);
  const DeviceProperties* source =
      ::PROTOBUF_NAMESPACE_ID::DynamicCastToGenerated<DeviceProperties>(
          &from);
  if (source == nullptr) {
  // @@protoc_insertion_point(generalized_merge_from_cast_fail:mascot.DeviceProperties)
    ::PROTOBUF_NAMESPACE_ID::internal::ReflectionOps::Merge(from, this);
  } else {
  // @@protoc_insertion_point(generalized_merge_from_cast_success:mascot.DeviceProperties)
    MergeFrom(*source);
  }
}

void DeviceProperties::MergeFrom(const DeviceProperties& from) {
// @@protoc_insertion_point(class_specific_merge_from_start:mascot.DeviceProperties)
  GOOGLE_DCHECK_NE(&from, this);
  _internal_metadata_.MergeFrom<::PROTOBUF_NAMESPACE_ID::UnknownFieldSet>(from._internal_metadata_);
  ::PROTOBUF_NAMESPACE_ID::uint32 cached_has_bits = 0;
  (void) cached_has_bits;

  properties_.MergeFrom(from.properties_);
  if (from.devicename().size() > 0) {
    _internal_set_devicename(from._internal_devicename());
  }
}

void DeviceProperties::CopyFrom(const ::PROTOBUF_NAMESPACE_ID::Message& from) {
// @@protoc_insertion_point(generalized_copy_from_start:mascot.DeviceProperties)
  if (&from == this) return;
  Clear();
  MergeFrom(from);
}

void DeviceProperties::CopyFrom(const DeviceProperties& from) {
// @@protoc_insertion_point(class_specific_copy_from_start:mascot.DeviceProperties)
  if (&from == this) return;
  Clear();
  MergeFrom(from);
}

bool DeviceProperties::IsInitialized() const {
  return true;
}

void DeviceProperties::InternalSwap(DeviceProperties* other) {
  using std::swap;
  _internal_metadata_.Swap<::PROTOBUF_NAMESPACE_ID::UnknownFieldSet>(&other->_internal_metadata_);
  properties_.Swap(&other->properties_);
  devicename_.Swap(&other->devicename_, &::PROTOBUF_NAMESPACE_ID::internal::GetEmptyStringAlreadyInited(), GetArena());
}

::PROTOBUF_NAMESPACE_ID::Metadata DeviceProperties::GetMetadata() const {
  return GetMetadataStatic();
}


// ===================================================================

void ReadDeviceAttributeMetaMessage::InitAsDefaultInstance() {
}
class ReadDeviceAttributeMetaMessage::_Internal {
 public:
};

ReadDeviceAttributeMetaMessage::ReadDeviceAttributeMetaMessage(::PROTOBUF_NAMESPACE_ID::Arena* arena)
  : ::PROTOBUF_NAMESPACE_ID::Message(arena) {
  SharedCtor();
  RegisterArenaDtor(arena);
  // @@protoc_insertion_point(arena_constructor:mascot.ReadDeviceAttributeMetaMessage)
}
ReadDeviceAttributeMetaMessage::ReadDeviceAttributeMetaMessage(const ReadDeviceAttributeMetaMessage& from)
  : ::PROTOBUF_NAMESPACE_ID::Message() {
  _internal_metadata_.MergeFrom<::PROTOBUF_NAMESPACE_ID::UnknownFieldSet>(from._internal_metadata_);
  devicename_.UnsafeSetDefault(&::PROTOBUF_NAMESPACE_ID::internal::GetEmptyStringAlreadyInited());
  if (!from._internal_devicename().empty()) {
    devicename_.Set(&::PROTOBUF_NAMESPACE_ID::internal::GetEmptyStringAlreadyInited(), from._internal_devicename(),
      GetArena());
  }
  attributename_.UnsafeSetDefault(&::PROTOBUF_NAMESPACE_ID::internal::GetEmptyStringAlreadyInited());
  if (!from._internal_attributename().empty()) {
    attributename_.Set(&::PROTOBUF_NAMESPACE_ID::internal::GetEmptyStringAlreadyInited(), from._internal_attributename(),
      GetArena());
  }
  // @@protoc_insertion_point(copy_constructor:mascot.ReadDeviceAttributeMetaMessage)
}

void ReadDeviceAttributeMetaMessage::SharedCtor() {
  ::PROTOBUF_NAMESPACE_ID::internal::InitSCC(&scc_info_ReadDeviceAttributeMetaMessage_device_5fproperties_2eproto.base);
  devicename_.UnsafeSetDefault(&::PROTOBUF_NAMESPACE_ID::internal::GetEmptyStringAlreadyInited());
  attributename_.UnsafeSetDefault(&::PROTOBUF_NAMESPACE_ID::internal::GetEmptyStringAlreadyInited());
}

ReadDeviceAttributeMetaMessage::~ReadDeviceAttributeMetaMessage() {
  // @@protoc_insertion_point(destructor:mascot.ReadDeviceAttributeMetaMessage)
  SharedDtor();
  _internal_metadata_.Delete<::PROTOBUF_NAMESPACE_ID::UnknownFieldSet>();
}

void ReadDeviceAttributeMetaMessage::SharedDtor() {
  GOOGLE_DCHECK(GetArena() == nullptr);
  devicename_.DestroyNoArena(&::PROTOBUF_NAMESPACE_ID::internal::GetEmptyStringAlreadyInited());
  attributename_.DestroyNoArena(&::PROTOBUF_NAMESPACE_ID::internal::GetEmptyStringAlreadyInited());
}

void ReadDeviceAttributeMetaMessage::ArenaDtor(void* object) {
  ReadDeviceAttributeMetaMessage* _this = reinterpret_cast< ReadDeviceAttributeMetaMessage* >(object);
  (void)_this;
}
void ReadDeviceAttributeMetaMessage::RegisterArenaDtor(::PROTOBUF_NAMESPACE_ID::Arena*) {
}
void ReadDeviceAttributeMetaMessage::SetCachedSize(int size) const {
  _cached_size_.Set(size);
}
const ReadDeviceAttributeMetaMessage& ReadDeviceAttributeMetaMessage::default_instance() {
  ::PROTOBUF_NAMESPACE_ID::internal::InitSCC(&::scc_info_ReadDeviceAttributeMetaMessage_device_5fproperties_2eproto.base);
  return *internal_default_instance();
}


void ReadDeviceAttributeMetaMessage::Clear() {
// @@protoc_insertion_point(message_clear_start:mascot.ReadDeviceAttributeMetaMessage)
  ::PROTOBUF_NAMESPACE_ID::uint32 cached_has_bits = 0;
  // Prevent compiler warnings about cached_has_bits being unused
  (void) cached_has_bits;

  devicename_.ClearToEmpty(&::PROTOBUF_NAMESPACE_ID::internal::GetEmptyStringAlreadyInited(), GetArena());
  attributename_.ClearToEmpty(&::PROTOBUF_NAMESPACE_ID::internal::GetEmptyStringAlreadyInited(), GetArena());
  _internal_metadata_.Clear<::PROTOBUF_NAMESPACE_ID::UnknownFieldSet>();
}

const char* ReadDeviceAttributeMetaMessage::_InternalParse(const char* ptr, ::PROTOBUF_NAMESPACE_ID::internal::ParseContext* ctx) {
#define CHK_(x) if (PROTOBUF_PREDICT_FALSE(!(x))) goto failure
  ::PROTOBUF_NAMESPACE_ID::Arena* arena = GetArena(); (void)arena;
  while (!ctx->Done(&ptr)) {
    ::PROTOBUF_NAMESPACE_ID::uint32 tag;
    ptr = ::PROTOBUF_NAMESPACE_ID::internal::ReadTag(ptr, &tag);
    CHK_(ptr);
    switch (tag >> 3) {
      // string deviceName = 1;
      case 1:
        if (PROTOBUF_PREDICT_TRUE(static_cast<::PROTOBUF_NAMESPACE_ID::uint8>(tag) == 10)) {
          auto str = _internal_mutable_devicename();
          ptr = ::PROTOBUF_NAMESPACE_ID::internal::InlineGreedyStringParser(str, ptr, ctx);
          CHK_(::PROTOBUF_NAMESPACE_ID::internal::VerifyUTF8(str, "mascot.ReadDeviceAttributeMetaMessage.deviceName"));
          CHK_(ptr);
        } else goto handle_unusual;
        continue;
      // string attributeName = 2;
      case 2:
        if (PROTOBUF_PREDICT_TRUE(static_cast<::PROTOBUF_NAMESPACE_ID::uint8>(tag) == 18)) {
          auto str = _internal_mutable_attributename();
          ptr = ::PROTOBUF_NAMESPACE_ID::internal::InlineGreedyStringParser(str, ptr, ctx);
          CHK_(::PROTOBUF_NAMESPACE_ID::internal::VerifyUTF8(str, "mascot.ReadDeviceAttributeMetaMessage.attributeName"));
          CHK_(ptr);
        } else goto handle_unusual;
        continue;
      default: {
      handle_unusual:
        if ((tag & 7) == 4 || tag == 0) {
          ctx->SetLastTag(tag);
          goto success;
        }
        ptr = UnknownFieldParse(tag,
            _internal_metadata_.mutable_unknown_fields<::PROTOBUF_NAMESPACE_ID::UnknownFieldSet>(),
            ptr, ctx);
        CHK_(ptr != nullptr);
        continue;
      }
    }  // switch
  }  // while
success:
  return ptr;
failure:
  ptr = nullptr;
  goto success;
#undef CHK_
}

::PROTOBUF_NAMESPACE_ID::uint8* ReadDeviceAttributeMetaMessage::_InternalSerialize(
    ::PROTOBUF_NAMESPACE_ID::uint8* target, ::PROTOBUF_NAMESPACE_ID::io::EpsCopyOutputStream* stream) const {
  // @@protoc_insertion_point(serialize_to_array_start:mascot.ReadDeviceAttributeMetaMessage)
  ::PROTOBUF_NAMESPACE_ID::uint32 cached_has_bits = 0;
  (void) cached_has_bits;

  // string deviceName = 1;
  if (this->devicename().size() > 0) {
    ::PROTOBUF_NAMESPACE_ID::internal::WireFormatLite::VerifyUtf8String(
      this->_internal_devicename().data(), static_cast<int>(this->_internal_devicename().length()),
      ::PROTOBUF_NAMESPACE_ID::internal::WireFormatLite::SERIALIZE,
      "mascot.ReadDeviceAttributeMetaMessage.deviceName");
    target = stream->WriteStringMaybeAliased(
        1, this->_internal_devicename(), target);
  }

  // string attributeName = 2;
  if (this->attributename().size() > 0) {
    ::PROTOBUF_NAMESPACE_ID::internal::WireFormatLite::VerifyUtf8String(
      this->_internal_attributename().data(), static_cast<int>(this->_internal_attributename().length()),
      ::PROTOBUF_NAMESPACE_ID::internal::WireFormatLite::SERIALIZE,
      "mascot.ReadDeviceAttributeMetaMessage.attributeName");
    target = stream->WriteStringMaybeAliased(
        2, this->_internal_attributename(), target);
  }

  if (PROTOBUF_PREDICT_FALSE(_internal_metadata_.have_unknown_fields())) {
    target = ::PROTOBUF_NAMESPACE_ID::internal::WireFormat::InternalSerializeUnknownFieldsToArray(
        _internal_metadata_.unknown_fields<::PROTOBUF_NAMESPACE_ID::UnknownFieldSet>(::PROTOBUF_NAMESPACE_ID::UnknownFieldSet::default_instance), target, stream);
  }
  // @@protoc_insertion_point(serialize_to_array_end:mascot.ReadDeviceAttributeMetaMessage)
  return target;
}

size_t ReadDeviceAttributeMetaMessage::ByteSizeLong() const {
// @@protoc_insertion_point(message_byte_size_start:mascot.ReadDeviceAttributeMetaMessage)
  size_t total_size = 0;

  ::PROTOBUF_NAMESPACE_ID::uint32 cached_has_bits = 0;
  // Prevent compiler warnings about cached_has_bits being unused
  (void) cached_has_bits;

  // string deviceName = 1;
  if (this->devicename().size() > 0) {
    total_size += 1 +
      ::PROTOBUF_NAMESPACE_ID::internal::WireFormatLite::StringSize(
        this->_internal_devicename());
  }

  // string attributeName = 2;
  if (this->attributename().size() > 0) {
    total_size += 1 +
      ::PROTOBUF_NAMESPACE_ID::internal::WireFormatLite::StringSize(
        this->_internal_attributename());
  }

  if (PROTOBUF_PREDICT_FALSE(_internal_metadata_.have_unknown_fields())) {
    return ::PROTOBUF_NAMESPACE_ID::internal::ComputeUnknownFieldsSize(
        _internal_metadata_, total_size, &_cached_size_);
  }
  int cached_size = ::PROTOBUF_NAMESPACE_ID::internal::ToCachedSize(total_size);
  SetCachedSize(cached_size);
  return total_size;
}

void ReadDeviceAttributeMetaMessage::MergeFrom(const ::PROTOBUF_NAMESPACE_ID::Message& from) {
// @@protoc_insertion_point(generalized_merge_from_start:mascot.ReadDeviceAttributeMetaMessage)
  GOOGLE_DCHECK_NE(&from, this);
  const ReadDeviceAttributeMetaMessage* source =
      ::PROTOBUF_NAMESPACE_ID::DynamicCastToGenerated<ReadDeviceAttributeMetaMessage>(
          &from);
  if (source == nullptr) {
  // @@protoc_insertion_point(generalized_merge_from_cast_fail:mascot.ReadDeviceAttributeMetaMessage)
    ::PROTOBUF_NAMESPACE_ID::internal::ReflectionOps::Merge(from, this);
  } else {
  // @@protoc_insertion_point(generalized_merge_from_cast_success:mascot.ReadDeviceAttributeMetaMessage)
    MergeFrom(*source);
  }
}

void ReadDeviceAttributeMetaMessage::MergeFrom(const ReadDeviceAttributeMetaMessage& from) {
// @@protoc_insertion_point(class_specific_merge_from_start:mascot.ReadDeviceAttributeMetaMessage)
  GOOGLE_DCHECK_NE(&from, this);
  _internal_metadata_.MergeFrom<::PROTOBUF_NAMESPACE_ID::UnknownFieldSet>(from._internal_metadata_);
  ::PROTOBUF_NAMESPACE_ID::uint32 cached_has_bits = 0;
  (void) cached_has_bits;

  if (from.devicename().size() > 0) {
    _internal_set_devicename(from._internal_devicename());
  }
  if (from.attributename().size() > 0) {
    _internal_set_attributename(from._internal_attributename());
  }
}

void ReadDeviceAttributeMetaMessage::CopyFrom(const ::PROTOBUF_NAMESPACE_ID::Message& from) {
// @@protoc_insertion_point(generalized_copy_from_start:mascot.ReadDeviceAttributeMetaMessage)
  if (&from == this) return;
  Clear();
  MergeFrom(from);
}

void ReadDeviceAttributeMetaMessage::CopyFrom(const ReadDeviceAttributeMetaMessage& from) {
// @@protoc_insertion_point(class_specific_copy_from_start:mascot.ReadDeviceAttributeMetaMessage)
  if (&from == this) return;
  Clear();
  MergeFrom(from);
}

bool ReadDeviceAttributeMetaMessage::IsInitialized() const {
  return true;
}

void ReadDeviceAttributeMetaMessage::InternalSwap(ReadDeviceAttributeMetaMessage* other) {
  using std::swap;
  _internal_metadata_.Swap<::PROTOBUF_NAMESPACE_ID::UnknownFieldSet>(&other->_internal_metadata_);
  devicename_.Swap(&other->devicename_, &::PROTOBUF_NAMESPACE_ID::internal::GetEmptyStringAlreadyInited(), GetArena());
  attributename_.Swap(&other->attributename_, &::PROTOBUF_NAMESPACE_ID::internal::GetEmptyStringAlreadyInited(), GetArena());
}

::PROTOBUF_NAMESPACE_ID::Metadata ReadDeviceAttributeMetaMessage::GetMetadata() const {
  return GetMetadataStatic();
}


// ===================================================================

DeviceAttributeMeta_MetaEntry_DoNotUse::DeviceAttributeMeta_MetaEntry_DoNotUse() {}
DeviceAttributeMeta_MetaEntry_DoNotUse::DeviceAttributeMeta_MetaEntry_DoNotUse(::PROTOBUF_NAMESPACE_ID::Arena* arena)
    : SuperType(arena) {}
void DeviceAttributeMeta_MetaEntry_DoNotUse::MergeFrom(const DeviceAttributeMeta_MetaEntry_DoNotUse& other) {
  MergeFromInternal(other);
}
::PROTOBUF_NAMESPACE_ID::Metadata DeviceAttributeMeta_MetaEntry_DoNotUse::GetMetadata() const {
  return GetMetadataStatic();
}
void DeviceAttributeMeta_MetaEntry_DoNotUse::MergeFrom(
    const ::PROTOBUF_NAMESPACE_ID::Message& other) {
  ::PROTOBUF_NAMESPACE_ID::Message::MergeFrom(other);
}


// ===================================================================

void DeviceAttributeMeta::InitAsDefaultInstance() {
}
class DeviceAttributeMeta::_Internal {
 public:
};

DeviceAttributeMeta::DeviceAttributeMeta(::PROTOBUF_NAMESPACE_ID::Arena* arena)
  : ::PROTOBUF_NAMESPACE_ID::Message(arena),
  meta_(arena) {
  SharedCtor();
  RegisterArenaDtor(arena);
  // @@protoc_insertion_point(arena_constructor:mascot.DeviceAttributeMeta)
}
DeviceAttributeMeta::DeviceAttributeMeta(const DeviceAttributeMeta& from)
  : ::PROTOBUF_NAMESPACE_ID::Message() {
  _internal_metadata_.MergeFrom<::PROTOBUF_NAMESPACE_ID::UnknownFieldSet>(from._internal_metadata_);
  meta_.MergeFrom(from.meta_);
  devicename_.UnsafeSetDefault(&::PROTOBUF_NAMESPACE_ID::internal::GetEmptyStringAlreadyInited());
  if (!from._internal_devicename().empty()) {
    devicename_.Set(&::PROTOBUF_NAMESPACE_ID::internal::GetEmptyStringAlreadyInited(), from._internal_devicename(),
      GetArena());
  }
  attributename_.UnsafeSetDefault(&::PROTOBUF_NAMESPACE_ID::internal::GetEmptyStringAlreadyInited());
  if (!from._internal_attributename().empty()) {
    attributename_.Set(&::PROTOBUF_NAMESPACE_ID::internal::GetEmptyStringAlreadyInited(), from._internal_attributename(),
      GetArena());
  }
  // @@protoc_insertion_point(copy_constructor:mascot.DeviceAttributeMeta)
}

void DeviceAttributeMeta::SharedCtor() {
  ::PROTOBUF_NAMESPACE_ID::internal::InitSCC(&scc_info_DeviceAttributeMeta_device_5fproperties_2eproto.base);
  devicename_.UnsafeSetDefault(&::PROTOBUF_NAMESPACE_ID::internal::GetEmptyStringAlreadyInited());
  attributename_.UnsafeSetDefault(&::PROTOBUF_NAMESPACE_ID::internal::GetEmptyStringAlreadyInited());
}

DeviceAttributeMeta::~DeviceAttributeMeta() {
  // @@protoc_insertion_point(destructor:mascot.DeviceAttributeMeta)
  SharedDtor();
  _internal_metadata_.Delete<::PROTOBUF_NAMESPACE_ID::UnknownFieldSet>();
}

void DeviceAttributeMeta::SharedDtor() {
  GOOGLE_DCHECK(GetArena() == nullptr);
  devicename_.DestroyNoArena(&::PROTOBUF_NAMESPACE_ID::internal::GetEmptyStringAlreadyInited());
  attributename_.DestroyNoArena(&::PROTOBUF_NAMESPACE_ID::internal::GetEmptyStringAlreadyInited());
}

void DeviceAttributeMeta::ArenaDtor(void* object) {
  DeviceAttributeMeta* _this = reinterpret_cast< DeviceAttributeMeta* >(object);
  (void)_this;
}
void DeviceAttributeMeta::RegisterArenaDtor(::PROTOBUF_NAMESPACE_ID::Arena*) {
}
void DeviceAttributeMeta::SetCachedSize(int size) const {
  _cached_size_.Set(size);
}
const DeviceAttributeMeta& DeviceAttributeMeta::default_instance() {
  ::PROTOBUF_NAMESPACE_ID::internal::InitSCC(&::scc_info_DeviceAttributeMeta_device_5fproperties_2eproto.base);
  return *internal_default_instance();
}


void DeviceAttributeMeta::Clear() {
// @@protoc_insertion_point(message_clear_start:mascot.DeviceAttributeMeta)
  ::PROTOBUF_NAMESPACE_ID::uint32 cached_has_bits = 0;
  // Prevent compiler warnings about cached_has_bits being unused
  (void) cached_has_bits;

  meta_.Clear();
  devicename_.ClearToEmpty(&::PROTOBUF_NAMESPACE_ID::internal::GetEmptyStringAlreadyInited(), GetArena());
  attributename_.ClearToEmpty(&::PROTOBUF_NAMESPACE_ID::internal::GetEmptyStringAlreadyInited(), GetArena());
  _internal_metadata_.Clear<::PROTOBUF_NAMESPACE_ID::UnknownFieldSet>();
}

const char* DeviceAttributeMeta::_InternalParse(const char* ptr, ::PROTOBUF_NAMESPACE_ID::internal::ParseContext* ctx) {
#define CHK_(x) if (PROTOBUF_PREDICT_FALSE(!(x))) goto failure
  ::PROTOBUF_NAMESPACE_ID::Arena* arena = GetArena(); (void)arena;
  while (!ctx->Done(&ptr)) {
    ::PROTOBUF_NAMESPACE_ID::uint32 tag;
    ptr = ::PROTOBUF_NAMESPACE_ID::internal::ReadTag(ptr, &tag);
    CHK_(ptr);
    switch (tag >> 3) {
      // string deviceName = 1;
      case 1:
        if (PROTOBUF_PREDICT_TRUE(static_cast<::PROTOBUF_NAMESPACE_ID::uint8>(tag) == 10)) {
          auto str = _internal_mutable_devicename();
          ptr = ::PROTOBUF_NAMESPACE_ID::internal::InlineGreedyStringParser(str, ptr, ctx);
          CHK_(::PROTOBUF_NAMESPACE_ID::internal::VerifyUTF8(str, "mascot.DeviceAttributeMeta.deviceName"));
          CHK_(ptr);
        } else goto handle_unusual;
        continue;
      // string attributeName = 2;
      case 2:
        if (PROTOBUF_PREDICT_TRUE(static_cast<::PROTOBUF_NAMESPACE_ID::uint8>(tag) == 18)) {
          auto str = _internal_mutable_attributename();
          ptr = ::PROTOBUF_NAMESPACE_ID::internal::InlineGreedyStringParser(str, ptr, ctx);
          CHK_(::PROTOBUF_NAMESPACE_ID::internal::VerifyUTF8(str, "mascot.DeviceAttributeMeta.attributeName"));
          CHK_(ptr);
        } else goto handle_unusual;
        continue;
      // map<string, string> meta = 3;
      case 3:
        if (PROTOBUF_PREDICT_TRUE(static_cast<::PROTOBUF_NAMESPACE_ID::uint8>(tag) == 26)) {
          ptr -= 1;
          do {
            ptr += 1;
            ptr = ctx->ParseMessage(&meta_, ptr);
            CHK_(ptr);
            if (!ctx->DataAvailable(ptr)) break;
          } while (::PROTOBUF_NAMESPACE_ID::internal::ExpectTag<26>(ptr));
        } else goto handle_unusual;
        continue;
      default: {
      handle_unusual:
        if ((tag & 7) == 4 || tag == 0) {
          ctx->SetLastTag(tag);
          goto success;
        }
        ptr = UnknownFieldParse(tag,
            _internal_metadata_.mutable_unknown_fields<::PROTOBUF_NAMESPACE_ID::UnknownFieldSet>(),
            ptr, ctx);
        CHK_(ptr != nullptr);
        continue;
      }
    }  // switch
  }  // while
success:
  return ptr;
failure:
  ptr = nullptr;
  goto success;
#undef CHK_
}

::PROTOBUF_NAMESPACE_ID::uint8* DeviceAttributeMeta::_InternalSerialize(
    ::PROTOBUF_NAMESPACE_ID::uint8* target, ::PROTOBUF_NAMESPACE_ID::io::EpsCopyOutputStream* stream) const {
  // @@protoc_insertion_point(serialize_to_array_start:mascot.DeviceAttributeMeta)
  ::PROTOBUF_NAMESPACE_ID::uint32 cached_has_bits = 0;
  (void) cached_has_bits;

  // string deviceName = 1;
  if (this->devicename().size() > 0) {
    ::PROTOBUF_NAMESPACE_ID::internal::WireFormatLite::VerifyUtf8String(
      this->_internal_devicename().data(), static_cast<int>(this->_internal_devicename().length()),
      ::PROTOBUF_NAMESPACE_ID::internal::WireFormatLite::SERIALIZE,
      "mascot.DeviceAttributeMeta.deviceName");
    target = stream->WriteStringMaybeAliased(
        1, this->_internal_devicename(), target);
  }

  // string attributeName = 2;
  if (this->attributename().size() > 0) {
    ::PROTOBUF_NAMESPACE_ID::internal::WireFormatLite::VerifyUtf8String(
      this->_internal_attributename().data(), static_cast<int>(this->_internal_attributename().length()),
      ::PROTOBUF_NAMESPACE_ID::internal::WireFormatLite::SERIALIZE,
      "mascot.DeviceAttributeMeta.attributeName");
    target = stream->WriteStringMaybeAliased(
        2, this->_internal_attributename(), target);
  }

  // map<string, string> meta = 3;
  if (!this->_internal_meta().empty()) {
    typedef ::PROTOBUF_NAMESPACE_ID::Map< std::string, std::string >::const_pointer
        ConstPtr;
    typedef ConstPtr SortItem;
    typedef ::PROTOBUF_NAMESPACE_ID::internal::CompareByDerefFirst<SortItem> Less;
    struct Utf8Check {
      static void Check(ConstPtr p) {
        ::PROTOBUF_NAMESPACE_ID::internal::WireFormatLite::VerifyUtf8String(
          p->first.data(), static_cast<int>(p->first.length()),
          ::PROTOBUF_NAMESPACE_ID::internal::WireFormatLite::SERIALIZE,
          "mascot.DeviceAttributeMeta.MetaEntry.key");
        ::PROTOBUF_NAMESPACE_ID::internal::WireFormatLite::VerifyUtf8String(
          p->second.data(), static_cast<int>(p->second.length()),
          ::PROTOBUF_NAMESPACE_ID::internal::WireFormatLite::SERIALIZE,
          "mascot.DeviceAttributeMeta.MetaEntry.value");
      }
    };

    if (stream->IsSerializationDeterministic() &&
        this->_internal_meta().size() > 1) {
      ::std::unique_ptr<SortItem[]> items(
          new SortItem[this->_internal_meta().size()]);
      typedef ::PROTOBUF_NAMESPACE_ID::Map< std::string, std::string >::size_type size_type;
      size_type n = 0;
      for (::PROTOBUF_NAMESPACE_ID::Map< std::string, std::string >::const_iterator
          it = this->_internal_meta().begin();
          it != this->_internal_meta().end(); ++it, ++n) {
        items[static_cast<ptrdiff_t>(n)] = SortItem(&*it);
      }
      ::std::sort(&items[0], &items[static_cast<ptrdiff_t>(n)], Less());
      for (size_type i = 0; i < n; i++) {
        target = DeviceAttributeMeta_MetaEntry_DoNotUse::Funcs::InternalSerialize(3, items[static_cast<ptrdiff_t>(i)]->first, items[static_cast<ptrdiff_t>(i)]->second, target, stream);
        Utf8Check::Check(&(*items[static_cast<ptrdiff_t>(i)]));
      }
    } else {
      for (::PROTOBUF_NAMESPACE_ID::Map< std::string, std::string >::const_iterator
          it = this->_internal_meta().begin();
          it != this->_internal_meta().end(); ++it) {
        target = DeviceAttributeMeta_MetaEntry_DoNotUse::Funcs::InternalSerialize(3, it->first, it->second, target, stream);
        Utf8Check::Check(&(*it));
      }
    }
  }

  if (PROTOBUF_PREDICT_FALSE(_internal_metadata_.have_unknown_fields())) {
    target = ::PROTOBUF_NAMESPACE_ID::internal::WireFormat::InternalSerializeUnknownFieldsToArray(
        _internal_metadata_.unknown_fields<::PROTOBUF_NAMESPACE_ID::UnknownFieldSet>(::PROTOBUF_NAMESPACE_ID::UnknownFieldSet::default_instance), target, stream);
  }
  // @@protoc_insertion_point(serialize_to_array_end:mascot.DeviceAttributeMeta)
  return target;
}

size_t DeviceAttributeMeta::ByteSizeLong() const {
// @@protoc_insertion_point(message_byte_size_start:mascot.DeviceAttributeMeta)
  size_t total_size = 0;

  ::PROTOBUF_NAMESPACE_ID::uint32 cached_has_bits = 0;
  // Prevent compiler warnings about cached_has_bits being unused
  (void) cached_has_bits;

  // map<string, string> meta = 3;
  total_size += 1 *
      ::PROTOBUF_NAMESPACE_ID::internal::FromIntSize(this->_internal_meta_size());
  for (::PROTOBUF_NAMESPACE_ID::Map< std::string, std::string >::const_iterator
      it = this->_internal_meta().begin();
      it != this->_internal_meta().end(); ++it) {
    total_size += DeviceAttributeMeta_MetaEntry_DoNotUse::Funcs::ByteSizeLong(it->first, it->second);
  }

  // string deviceName = 1;
  if (this->devicename().size() > 0) {
    total_size += 1 +
      ::PROTOBUF_NAMESPACE_ID::internal::WireFormatLite::StringSize(
        this->_internal_devicename());
  }

  // string attributeName = 2;
  if (this->attributename().size() > 0) {
    total_size += 1 +
      ::PROTOBUF_NAMESPACE_ID::internal::WireFormatLite::StringSize(
        this->_internal_attributename());
  }

  if (PROTOBUF_PREDICT_FALSE(_internal_metadata_.have_unknown_fields())) {
    return ::PROTOBUF_NAMESPACE_ID::internal::ComputeUnknownFieldsSize(
        _internal_metadata_, total_size, &_cached_size_);
  }
  int cached_size = ::PROTOBUF_NAMESPACE_ID::internal::ToCachedSize(total_size);
  SetCachedSize(cached_size);
  return total_size;
}

void DeviceAttributeMeta::MergeFrom(const ::PROTOBUF_NAMESPACE_ID::Message& from) {
// @@protoc_insertion_point(generalized_merge_from_start:mascot.DeviceAttributeMeta)
  GOOGLE_DCHECK_NE(&from, this);
  const DeviceAttributeMeta* source =
      ::PROTOBUF_NAMESPACE_ID::DynamicCastToGenerated<DeviceAttributeMeta>(
          &from);
  if (source == nullptr) {
  // @@protoc_insertion_point(generalized_merge_from_cast_fail:mascot.DeviceAttributeMeta)
    ::PROTOBUF_NAMESPACE_ID::internal::ReflectionOps::Merge(from, this);
  } else {
  // @@protoc_insertion_point(generalized_merge_from_cast_success:mascot.DeviceAttributeMeta)
    MergeFrom(*source);
  }
}

void DeviceAttributeMeta::MergeFrom(const DeviceAttributeMeta& from) {
// @@protoc_insertion_point(class_specific_merge_from_start:mascot.DeviceAttributeMeta)
  GOOGLE_DCHECK_NE(&from, this);
  _internal_metadata_.MergeFrom<::PROTOBUF_NAMESPACE_ID::UnknownFieldSet>(from._internal_metadata_);
  ::PROTOBUF_NAMESPACE_ID::uint32 cached_has_bits = 0;
  (void) cached_has_bits;

  meta_.MergeFrom(from.meta_);
  if (from.devicename().size() > 0) {
    _internal_set_devicename(from._internal_devicename());
  }
  if (from.attributename().size() > 0) {
    _internal_set_attributename(from._internal_attributename());
  }
}

void DeviceAttributeMeta::CopyFrom(const ::PROTOBUF_NAMESPACE_ID::Message& from) {
// @@protoc_insertion_point(generalized_copy_from_start:mascot.DeviceAttributeMeta)
  if (&from == this) return;
  Clear();
  MergeFrom(from);
}

void DeviceAttributeMeta::CopyFrom(const DeviceAttributeMeta& from) {
// @@protoc_insertion_point(class_specific_copy_from_start:mascot.DeviceAttributeMeta)
  if (&from == this) return;
  Clear();
  MergeFrom(from);
}

bool DeviceAttributeMeta::IsInitialized() const {
  return true;
}

void DeviceAttributeMeta::InternalSwap(DeviceAttributeMeta* other) {
  using std::swap;
  _internal_metadata_.Swap<::PROTOBUF_NAMESPACE_ID::UnknownFieldSet>(&other->_internal_metadata_);
  meta_.Swap(&other->meta_);
  devicename_.Swap(&other->devicename_, &::PROTOBUF_NAMESPACE_ID::internal::GetEmptyStringAlreadyInited(), GetArena());
  attributename_.Swap(&other->attributename_, &::PROTOBUF_NAMESPACE_ID::internal::GetEmptyStringAlreadyInited(), GetArena());
}

::PROTOBUF_NAMESPACE_ID::Metadata DeviceAttributeMeta::GetMetadata() const {
  return GetMetadataStatic();
}


// @@protoc_insertion_point(namespace_scope)
}  // namespace mascot
PROTOBUF_NAMESPACE_OPEN
template<> PROTOBUF_NOINLINE ::mascot::ReadDevicePropertiesMessage* Arena::CreateMaybeMessage< ::mascot::ReadDevicePropertiesMessage >(Arena* arena) {
  return Arena::CreateMessageInternal< ::mascot::ReadDevicePropertiesMessage >(arena);
}
template<> PROTOBUF_NOINLINE ::mascot::DeviceProperties_PropertiesEntry_DoNotUse* Arena::CreateMaybeMessage< ::mascot::DeviceProperties_PropertiesEntry_DoNotUse >(Arena* arena) {
  return Arena::CreateMessageInternal< ::mascot::DeviceProperties_PropertiesEntry_DoNotUse >(arena);
}
template<> PROTOBUF_NOINLINE ::mascot::DeviceProperties* Arena::CreateMaybeMessage< ::mascot::DeviceProperties >(Arena* arena) {
  return Arena::CreateMessageInternal< ::mascot::DeviceProperties >(arena);
}
template<> PROTOBUF_NOINLINE ::mascot::ReadDeviceAttributeMetaMessage* Arena::CreateMaybeMessage< ::mascot::ReadDeviceAttributeMetaMessage >(Arena* arena) {
  return Arena::CreateMessageInternal< ::mascot::ReadDeviceAttributeMetaMessage >(arena);
}
template<> PROTOBUF_NOINLINE ::mascot::DeviceAttributeMeta_MetaEntry_DoNotUse* Arena::CreateMaybeMessage< ::mascot::DeviceAttributeMeta_MetaEntry_DoNotUse >(Arena* arena) {
  return Arena::CreateMessageInternal< ::mascot::DeviceAttributeMeta_MetaEntry_DoNotUse >(arena);
}
template<> PROTOBUF_NOINLINE ::mascot::DeviceAttributeMeta* Arena::CreateMaybeMessage< ::mascot::DeviceAttributeMeta >(Arena* arena) {
  return Arena::CreateMessageInternal< ::mascot::DeviceAttributeMeta >(arena);
}
PROTOBUF_NAMESPACE_CLOSE

// @@protoc_insertion_point(global_scope)
#include <google/protobuf/port_undef.inc>
